/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ExternalIntegrationsUnzer type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExternalIntegrationsUnzer{}

// ExternalIntegrationsUnzer struct for ExternalIntegrationsUnzer
type ExternalIntegrationsUnzer struct {
	PrivateKey *string `json:"private_key,omitempty"`
	PublicKey *string `json:"public_key,omitempty"`
	WebhookId *string `json:"webhook_id,omitempty"`
}

// NewExternalIntegrationsUnzer instantiates a new ExternalIntegrationsUnzer object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExternalIntegrationsUnzer() *ExternalIntegrationsUnzer {
	this := ExternalIntegrationsUnzer{}
	return &this
}

// NewExternalIntegrationsUnzerWithDefaults instantiates a new ExternalIntegrationsUnzer object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExternalIntegrationsUnzerWithDefaults() *ExternalIntegrationsUnzer {
	this := ExternalIntegrationsUnzer{}
	return &this
}

// GetPrivateKey returns the PrivateKey field value if set, zero value otherwise.
func (o *ExternalIntegrationsUnzer) GetPrivateKey() string {
	if o == nil || IsNil(o.PrivateKey) {
		var ret string
		return ret
	}
	return *o.PrivateKey
}

// GetPrivateKeyOk returns a tuple with the PrivateKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExternalIntegrationsUnzer) GetPrivateKeyOk() (*string, bool) {
	if o == nil || IsNil(o.PrivateKey) {
		return nil, false
	}
	return o.PrivateKey, true
}

// HasPrivateKey returns a boolean if a field has been set.
func (o *ExternalIntegrationsUnzer) HasPrivateKey() bool {
	if o != nil && !IsNil(o.PrivateKey) {
		return true
	}

	return false
}

// SetPrivateKey gets a reference to the given string and assigns it to the PrivateKey field.
func (o *ExternalIntegrationsUnzer) SetPrivateKey(v string) {
	o.PrivateKey = &v
}

// GetPublicKey returns the PublicKey field value if set, zero value otherwise.
func (o *ExternalIntegrationsUnzer) GetPublicKey() string {
	if o == nil || IsNil(o.PublicKey) {
		var ret string
		return ret
	}
	return *o.PublicKey
}

// GetPublicKeyOk returns a tuple with the PublicKey field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExternalIntegrationsUnzer) GetPublicKeyOk() (*string, bool) {
	if o == nil || IsNil(o.PublicKey) {
		return nil, false
	}
	return o.PublicKey, true
}

// HasPublicKey returns a boolean if a field has been set.
func (o *ExternalIntegrationsUnzer) HasPublicKey() bool {
	if o != nil && !IsNil(o.PublicKey) {
		return true
	}

	return false
}

// SetPublicKey gets a reference to the given string and assigns it to the PublicKey field.
func (o *ExternalIntegrationsUnzer) SetPublicKey(v string) {
	o.PublicKey = &v
}

// GetWebhookId returns the WebhookId field value if set, zero value otherwise.
func (o *ExternalIntegrationsUnzer) GetWebhookId() string {
	if o == nil || IsNil(o.WebhookId) {
		var ret string
		return ret
	}
	return *o.WebhookId
}

// GetWebhookIdOk returns a tuple with the WebhookId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExternalIntegrationsUnzer) GetWebhookIdOk() (*string, bool) {
	if o == nil || IsNil(o.WebhookId) {
		return nil, false
	}
	return o.WebhookId, true
}

// HasWebhookId returns a boolean if a field has been set.
func (o *ExternalIntegrationsUnzer) HasWebhookId() bool {
	if o != nil && !IsNil(o.WebhookId) {
		return true
	}

	return false
}

// SetWebhookId gets a reference to the given string and assigns it to the WebhookId field.
func (o *ExternalIntegrationsUnzer) SetWebhookId(v string) {
	o.WebhookId = &v
}

func (o ExternalIntegrationsUnzer) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExternalIntegrationsUnzer) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.PrivateKey) {
		toSerialize["private_key"] = o.PrivateKey
	}
	if !IsNil(o.PublicKey) {
		toSerialize["public_key"] = o.PublicKey
	}
	if !IsNil(o.WebhookId) {
		toSerialize["webhook_id"] = o.WebhookId
	}
	return toSerialize, nil
}

type NullableExternalIntegrationsUnzer struct {
	value *ExternalIntegrationsUnzer
	isSet bool
}

func (v NullableExternalIntegrationsUnzer) Get() *ExternalIntegrationsUnzer {
	return v.value
}

func (v *NullableExternalIntegrationsUnzer) Set(val *ExternalIntegrationsUnzer) {
	v.value = val
	v.isSet = true
}

func (v NullableExternalIntegrationsUnzer) IsSet() bool {
	return v.isSet
}

func (v *NullableExternalIntegrationsUnzer) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExternalIntegrationsUnzer(val *ExternalIntegrationsUnzer) *NullableExternalIntegrationsUnzer {
	return &NullableExternalIntegrationsUnzer{value: val, isSet: true}
}

func (v NullableExternalIntegrationsUnzer) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExternalIntegrationsUnzer) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


